/*******************************************************************************
 * Copyright (c) 2008 ikv++ technologies ag and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     ikv++ technologies ag - initial API and implementation
 *******************************************************************************/

package de.ikv.medini.qvt.execution.debug.events;

/**
 * Event to signal suspension of execution
 * 
 * @author kiegeland
 * 
 */
public class QVTDebugEventSuspended extends QVTDebugEvent {

	public String toString() {
		return "suspended " + this.cause;
	}

	private QVTDebugEventSuspendedCause cause;

	/**
	 * 
	 * @param cause
	 *            Tells why execution is suspended
	 */
	public QVTDebugEventSuspended(QVTDebugEventSuspendedCause cause) {
		this.cause = cause;
	}

	public QVTDebugEventSuspendedCause getCause() {
		return this.cause;
	}

	/**
	 * Hash code based on {@link #cause}
	 * 
	 * Generated by Eclipse
	 */
	public int hashCode() {
		final int PRIME = 31;
		int result = 1;
		result = PRIME * result + (this.cause == null ? 0 : this.cause.hashCode());
		return result;
	}

	/**
	 * Equality based on {@link #cause}
	 * 
	 * Generated by Eclipse
	 */
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (this.getClass() != obj.getClass()) {
			return false;
		}
		final QVTDebugEventSuspended other = (QVTDebugEventSuspended) obj;
		if (this.cause == null) {
			if (other.cause != null) {
				return false;
			}
		} else if (!this.cause.equals(other.cause)) {
			return false;
		}
		return true;
	}

}
